Тёмный

Dynamic Programming 1D - Full Course - Python 

NeetCode
Подписаться 821 тыс.
Просмотров 251 тыс.
50% 1

Опубликовано:

 

25 сен 2024

Поделиться:

Ссылка:

Скачать:

Готовим ссылку...

Добавить в:

Мой плейлист
Посмотреть позже
Комментарии : 165   
@NeetCode
@NeetCode 2 года назад
🚀 neetcode.io - Get access to every current and future course I ever create. Spreadsheet from the video: docs.google.com/spreadsheets/d/1A2PaQKcdwO_lwxz9bAnxXnIQayCouZP6d-ENrBz_NXc/edit?usp=sharing
@hakeemdhayal8433
@hakeemdhayal8433 2 года назад
Hi Mr NeetCode dude, I just wanted to ask, do you have tier pricing that changes based on the country? For example, there are developing countries in Africa that generally tend to have a lower pricing since the $ is extremely high to the ZAR - South African Rand. There are other countries as well that would struggle. Do you intend on having a way to assist us too? I'm asking because you're having a launch sale and perhaps by the time you even get a chance to consider different tier pricing based on different countries it may be too late :( Do know however, I'm extremely grateful for the existence of NeetCode and everything that you've done!
@mybuddy11
@mybuddy11 2 года назад
Dear Neetcode, Could you please publish a video full course on graph theory
@sherazdotnet
@sherazdotnet 2 года назад
I'd like to share a few points. With DP, one of the main challenge is how do you recognize a problem is indeed a DP problem. It can be misleading at times that a given problem is indeed a DP problem. Therefore, I'd say that this course and more upcoming DP parts that you might be posting, would be great if you start each question with pure analysis of why this problem is a DP problem to begin with. Taking a view on the question as if it has never been seen and then you apply contain ideas to identify if its a DP problem or not. The reason I'm bringing this point is because it just so happened that one of my friend shared his experience with me that he had a few years ago where during interview, he thought the problem is a DP and after 25 mins in the interview, he realized that's its not but he had waisted essentially all the critical time. Long story short, would be great that for every question, would be great to talk about what attributes of such problem made it obvious that its a DP problem.
@emmanuelu
@emmanuelu 2 года назад
Facts. for me personally almost every question i do im always trying to look for a dp solution but i dont really know if it is a dp problem
@davesmith5043
@davesmith5043 Год назад
I get your point and I agree but I believe it's one of those things that you have to build an intuition for, in other words, it comes with practice.
@mrmotomoto
@mrmotomoto Год назад
In an algorithms class one first learns about greedy algorithms, then memoization before moving into DP. I think this helps build an intuition. So anyone looking to gain intuition about when DP is applicable may benefit from reading up on those concepts first, especially memoization. That said, the first example of the fibonacci sequence is a good start. Think of times where work has to be repeated because future calculations require the work of previous steps, as in the fibonacci sequence. With memoization, instead of re-calculating every step, we can save the results at each step and recall the solution in future function calls to speed up the time needed.
@ktm00072
@ktm00072 Год назад
Take this as how to recognise the problem is a DP: 1. With pen & paper, do the problem have sub-problems? 2. Does the sub-problems return similar value or in a pattern that will be used for next iteration(sub-problem)? If it is, then try to solve this way: 1. you can follow tabulation(array to store data) or memoisation(hashSet or hashMap). 2. Sometimes the problem may not ask for the dp array or dp hash, then you may use two variables(think these as pointers that may need to update at each iteration). At the end return the value.
@RandomShowerThoughts
@RandomShowerThoughts Год назад
Good question, another one that I have is how do we come to understand that there is a binary algorithm at place? Either we take the current value or we do not? It would appear that we could just loop through all possible options (except the current one), which would still work, but be slower and get a TLE on leetcode
@temik26
@temik26 2 года назад
You're doing amazing work for all who wants to be good at algorithms and pass interviews. Mad respect!
@mohammedumarfarhan9900
@mohammedumarfarhan9900 2 года назад
Thanks a lot brother. May God bless you abundantly
@lazzalicious6220
@lazzalicious6220 Год назад
Most loving RU-vid commenter
@AbhishekSingh-vl1dp
@AbhishekSingh-vl1dp Год назад
Can't believe he is an Indian 🫡😂
@peekaboo6026
@peekaboo6026 2 года назад
Ohhh neetcode only if I could express how much I owe you for improving my problem solving skills
@reebaqureshi9079
@reebaqureshi9079 Год назад
I've been watching your videos so much through my interview preparations that your voice sounds like a mother's lullaby to me at this point.
@rohithboppey3205
@rohithboppey3205 Год назад
I'm not sure who needs this, but I guess we can use the similar format for all 1D problems- class Solution { public: int solve(vector& ways, int n, int start){ if(start >= n){ // no way to reach the end return 0; } if(ways[start] != -1){ // already calculated return ways[start]; } // not cal // need to cal // it always depends on the next problem return ways[start] = solve(ways, n, start + 1) + solve(ways, n, start + 2); } int climbStairs(int n) { // using the concept of DP vector ways(n + 1, -1); if(n < 2){ return 1; } ways[n] = 0; ways[n-1] = 1; ways[n-2] = 2; // ways means number of ways we can reach the end // if the start position is i solve(ways, n, 0); return ways[0]; } };
@zizzlindawg1847
@zizzlindawg1847 2 года назад
This is amazing, thanks for all the work you do.
@aniquatabassum5428
@aniquatabassum5428 Год назад
In the climbing stairs problem, why is the value for the base case 1? If we are at the base case, then there are 0 ways to reach the base case right….? I realise if we initialise the base case to zero then the code won’t work. I just want to understand what other reason there is for the base case to be one.
@SkillR1
@SkillR1 5 месяцев назад
The original problem is about routes - how many routes can you take. from 5 to 5 you can take 1 route from 2 to 5 you can take the route that will lead you to 3, or the route that will lead you to 4
@b9944236
@b9944236 2 года назад
I paid for the lifetime membership yesterday, but this super long and helpful video is just for free. So, goodbye my money, I have to support this cool guy indeed.
@CyberMew
@CyberMew 2 года назад
that's a great pic of Son Ye-jin!
@Casanovajosh
@Casanovajosh 2 года назад
Well, this does not include the 20 mins 1D DP course in his pro member content. Your money is still worth it.
@jonathanpangilinanjr.9905
@jonathanpangilinanjr.9905 2 года назад
Thank you very much for this video. I finally solved my very own medium dp lc after watching a quarter of your video. I'm gonna finish this and hopefully, I can stand on my own feet after.
@undergrad4980
@undergrad4980 2 года назад
Dear Neetcode, thank you for uploading this. I have been following your content for quite some time and I really appreciate the effort you have put into creating content for DSA. However, I would really appreciate it if you could highlight the core in-depth reason for why such DP patterns exist, and how to identify them. So a template, instead of solutions.
@sherazdotnet
@sherazdotnet 2 года назад
DP is used when you have n ways to do something. Here that n is the number of steps you can take. The question can be changed to say you can can take 1 or 2 or 3 steps. Now if you give 20 stairs, you have 3 ways to get there. As you can see there is no straight forward answer. This is where DP comes in the picture. DP allows you to break the problem down into a very very small sub problem. Once you solve small sub problem then next problem builds on top of it. So instead of solving to 20 steps, solve it for smaller number. What's the smallest number you can solve it for???? 0. Also in dp questions where we have to count n ways, I find it much better approach to go backwards. Instead of finding ways to get to 20, find ways to get to 0. for 3 steps where you are allowed to take 1or 2 steps, it'd look like 3 2/ \1 1 2 2/ \1 2/ \ 1 -1 0 0 1 2 / \1 -1 0 Anytime you see 0, you have a positive case meaning that path will yield correct result. If value goes < 0, it means it won't work. So the code will look like public int GetCount(int totalSteps) { if(totalSteps == 0) return 1; if(totalSteps < 0) return 0; return GetCount(totalSteps-2) + GetCount(totalSteps-1); } Then you add memoization to optimize the time but you get the idea. Its an amazing concept but once you get a hang of it, you'd feel most satisfied solving these questions.
@cupofjava5480
@cupofjava5480 Год назад
@@sherazdotnet you're awesome
@malikau917
@malikau917 Год назад
@@sherazdotnet thanks bro
@vikasjha1064
@vikasjha1064 18 дней назад
Best playlist to learn DP. Thanks mate
@bubblesort8760
@bubblesort8760 2 года назад
The best timing. İ was in need of this. Thank you so much Sir.
@xzex2609
@xzex2609 Год назад
Climbing Stairs can be written in just three lines(instead of five), in python for swapping two variables you don't need a Temp variable, you can use a, b = b, a or ( one, two = one + two, one ) class Solution: def climbStairs(self, n: int) -> int: one, two = 1, 1 for i in range(n-1): one, two = one + two, one return one
@longvu7746
@longvu7746 Год назад
For anyone reading this, reason this works is because in python the expressions on the right side of the = sign are evaluated first, therefore one + two and one are calculated based on original values of one and two. Then it assigns the results to one and two on the left side
@house0795
@house0795 2 года назад
I agree, climbing stairs was indeed explained top notch.
@alexgabriel5877
@alexgabriel5877 2 года назад
great stuff! hope for other topics covered the same way!
@krishnamohantiwari1140
@krishnamohantiwari1140 2 года назад
Amazing!! Waiting for 2D DP :)
@ujjawalpanchal
@ujjawalpanchal Год назад
@neetcode Props on the great video! Are palindromic substrings and longest palindromic substrings relevant to DP? If not, why are they in this compilation?
@Hossein118
@Hossein118 Год назад
Absolutely love your content. It’s so neet and easy to follow for the layman. Do you have a Rumble channel as well?
@Vishal_84_k
@Vishal_84_k 2 года назад
Waiting for this ,best explaination ever 💥💥
@ruiqiyin3847
@ruiqiyin3847 2 года назад
This is what I'm looking for! Thank you!
@utkarshdewan8736
@utkarshdewan8736 2 года назад
Oh my man this was so needed thankyou so much sir ❤️
@curosity276
@curosity276 2 года назад
I really appreciate your work, your explanation really works
@petervan7372
@petervan7372 11 месяцев назад
13:20, at the last step 5, how many ways to land on the same step land on itself, why 1?
@eddiej204
@eddiej204 2 года назад
Bro, this is gold.
@svkrtrolls7438
@svkrtrolls7438 10 месяцев назад
great content
@sharksinvestment9864
@sharksinvestment9864 Год назад
Thanks neetcode
@sophiophile
@sophiophile 4 месяца назад
2:08:59 why is the third value in the min necessary (just n). cur_max can never be less than 1. If cur_max is 1, its the same as n, if its larger, it's bigger than n.
@ErenTal
@ErenTal Год назад
Hello everyone! I have a question regarding the problem 300 "Longest increasing subsequence". Why didn't we write: LIS = [1] * (len(nums)+1) instead of LIS = [1] * len(nums) For example, in the previous problem "Word Break" we've used the +1. In which cases do we use the +1 when we define dp and in which cases we do not? Thank you
@amospan14
@amospan14 2 года назад
Dude this is amazing material! Thank you so much for the education and your teachings! When I get a job, Ima have to take you out for lunch! Truly appreciate your work buddy =)
@sherazdotnet
@sherazdotnet 2 года назад
Here is my solution using Recursion + Memoization. Code is written in c# public int CountSteps(int totalSteps, Dictionary memo) { if(totalSteps ==0) { return 1; } if(totalSteps < 0) { return 0; } if(memo.ContainsKey(totalSteps)) { return memo[totalSteps]; } var usingOneStep = CountSteps(totalSteps-1, memo); var usingTwoSteps = CountSteps(totalSteps-2, memo); memo[totalSteps] = usingOneStep + usingTwoSteps; return memo[totalSteps]; }
@RohitRavula
@RohitRavula 2 года назад
Thanks a lot, We need more such full course vedios on each module, It really helps
@rustomshroff417
@rustomshroff417 11 месяцев назад
the two variable approach to solving the decode ways is missing in this video, but really helpful video. Thanks a lot.
@romo119
@romo119 Год назад
For problem "decode ways" Doesn't initializing dp[len(s] = 1 mean that null string can be decoded in 1 way? I understand how this works in code but conceptually I don't see how a null string can be decoded
@mikkiverma9545
@mikkiverma9545 2 года назад
Thanks neetcode eagerly waited for this, Hope u will upload this type of content more.
@jessanraj9086
@jessanraj9086 2 года назад
I Really appreciate these efforts you are taking man🔥
@sophiophile
@sophiophile 4 месяца назад
Can we improve the efficiency at 2:24:28 by mutating wordDict into the form where the key is len(word) and the value is a list of all words of that length (no extra space). Then we can check: for key in wordDict: if i+key in dp and dp[i + key] = True: for word in wordDict[key]: #check the word That way, you eliminate the vast majority of building dp.
@amandubey5287
@amandubey5287 2 года назад
You did it finaly, God Damn, you have no idea what great help you just did, damn bruh you are God sent
@pratyushpradhan2612
@pratyushpradhan2612 Год назад
For the first problem, why is it that we put 1 in 5. If we are already if 5 and we can either go up by. 1 or 2 then shouldn't the possible step be 0?(As we are already in the solution). Can someone clarify pls
@aniquatabassum5428
@aniquatabassum5428 Год назад
I have the same question
@10199able
@10199able Год назад
+1, because by this logic we should place 2 in 4
@DreamosStudio
@DreamosStudio Год назад
Wow, this is amazing tutorial, DP in many case (n*2) -1 or ( n- n,pow(2)) 😀, great work
@khirabdhitanaya8931
@khirabdhitanaya8931 10 месяцев назад
You. Are. Absolutely. Amazing!!!!
@rahuldey1182
@rahuldey1182 2 года назад
Neetcode is the Hero we dont deserve but the hero we needed. He is the Dark Knight of LeetCode.
@ra90451
@ra90451 3 месяца назад
Odd or even length strings does not matter static boolean isPallindrom(String str) { boolean isTrue =false; int l=0; int r =str.length()-1; while(r>l) { System.out.println(str); if (str.charAt(l)==str.charAt(r)) { isTrue=true; }; l++; r--; } return isTrue; }
@tofahub
@tofahub 2 года назад
Watching this in the weekend. I can't be happier
@evergreenyoung1181
@evergreenyoung1181 Год назад
For the last problem, can someone explain why the time complexity is not 2^n? If all the sum is unique, then the size of set should double each time, thus it's 2^n. Why doesn't this happen?
@godmodel33t11
@godmodel33t11 Год назад
For the first 1D example, why does the fib sequence start from 1 and not 0?
@the8426
@the8426 Год назад
I love this, Thank you! Can you do the same for dfs and bfs algorithms?
@mybuddy11
@mybuddy11 2 года назад
Dear Neetcode, Could you please publish a video full course on graph theory
@varadiganesh7389
@varadiganesh7389 3 месяца назад
Great stuff... Learnt a lot sir
@09TYPER
@09TYPER Год назад
Thanks!Could you do live dynamic programming session , so we can learn from your thought process?Btw( for 02:45:45 ) if the input array is [1,4,11,5} dont [1,4] and [5] is even subsets,even if they are not equal to half of sum of the array?
@347harsha
@347harsha 9 месяцев назад
Thanks Guru. You are my Dronacharya
@ek_minute_
@ek_minute_ Год назад
Thanks man. Respect from 🇮🇳
@intrepidm8753
@intrepidm8753 Год назад
love you dude.... if God is there... God bless you
@pawanchaturvedi8973
@pawanchaturvedi8973 2 года назад
Oh my God ! Can't thank you enough. Thank you so much for this
@chrisogonas
@chrisogonas Год назад
So incredible you could put in tonnes of hours into quality work. Thanks for creating this amazing resource.
@RajatSoni07
@RajatSoni07 6 месяцев назад
Very helpfull course, Highly recommended
@CyberMew
@CyberMew 2 года назад
Is this video a combination of all the previous videos cut together? or is it recut/edited to string together experiences drawn from previous questions?
@jamesbotwina8744
@jamesbotwina8744 2 года назад
That infinite loop while trying to add to the same set you are iterating through was confusing me. Thanks!
@saminhasan87
@saminhasan87 8 месяцев назад
this video helped me a lot. Thanks
@harryzachariou1
@harryzachariou1 2 года назад
Absolute legend for this!
@madhumithakolkar_
@madhumithakolkar_ 10 месяцев назад
Brute Forced a super inefficient piece of code :P : def wordBreak(self, s: str, wordDict: List[str]) -> bool: length = len(s) for w in wordDict: if length==0: return True while length>=0 and len(w)
@mayursonowal
@mayursonowal 2 года назад
You’re doing god’s work
@彭程-u8k
@彭程-u8k 7 месяцев назад
I have a question for Maximun Product Subarray. What if the array is just [0], your code will output 1 as u set curMax as 1 by default. However, the ans should be 0 right? Maybe I should deal with this case especially?
@akhildeshneni9922
@akhildeshneni9922 2 года назад
Thank you neetcode 🙌
@347harsha
@347harsha 8 месяцев назад
@NeeCode in house robber 2 problem(problem number 213) if the robber starts stealing from house somewhere in middle . is it not separate case we have to consider . so I think for each number in array we have to skip it and execute the helper function
@alexanderkuptsov6117
@alexanderkuptsov6117 Год назад
First of all, a lot of thanks for what you have done, such effort is priceless and let good things happen to you! :) Things I would have done differently: I have just finished watching the first problem, which is Climbing Stairs, and I have to say your approach to explaining it is a bit misleading in its final part. First, you're indexing your array from 0 to 5, but it's dp[0] that contains the number of ways to reach 5. At the same time dp[5] = 1 and that might be confusing because clearly there's more than 1 way to reach 5 from 0 to 5. I do realise that you decided to go backwards but why? Your initial explanation was from 0 to 5. Also, when you show the code, you have no array in there at all. Yes, it's clear that this problem is a plain Fib numbers problem, but for someone who's just started that might be confusing. Anyway, thank you for your effort and don't think of me as someone unthankful - I'm not. I've written all that for those who may struggle trying to understand these things because I've been there multiple times myself.
@qray862
@qray862 2 года назад
thank you for the contribution for the human kind.
@shashankvray9042
@shashankvray9042 2 года назад
MY MAN IS BACK
@xushenxin
@xushenxin Год назад
I didn't quite get it for the house robber 1 problem after watching 2 times. Maybe I failed in one key thought jump.
@pushkarchaubey8300
@pushkarchaubey8300 2 года назад
you are god for me and thanks for these dp course in python🙂🙂
@shivangitiwari2485
@shivangitiwari2485 6 месяцев назад
your voice is very appealing.
@ryangoodwin9115
@ryangoodwin9115 Год назад
im confused by what i see and what i hear. you say the for loop will run until it reaches the beginning of the array. but whats written is -3, -1, -1 so to my understand, it starts at index -3, then goes back -1 index every iteration, until it reaches the last index -1?? that makes no sense to me
@jasmin_bheda
@jasmin_bheda 2 года назад
Love you Neetcode ❤
@psibarpsi
@psibarpsi Год назад
Thanks a lot!
@PROJECTMartin
@PROJECTMartin 2 года назад
At 1:57:00 you're solving Maximum Product Subarray not Longest Increasing Subsequence
@NeetCode
@NeetCode 2 года назад
thanks, fixed
@rajibulalam2580
@rajibulalam2580 7 месяцев назад
Thanks!
@NeetCode
@NeetCode 7 месяцев назад
Thank you so much!!!
@infohub3709
@infohub3709 Год назад
@ 18:53 the code doesn't run well for a higher value of n. I tried with a value of 500,000. It hung.
@piyush1342
@piyush1342 2 года назад
Love you man you are the best
@nurhusni
@nurhusni Год назад
why is bottom up solution considered the "true" DP solution?
@Dishankjindal
@Dishankjindal 2 года назад
Amazing 👍🏼
@dheeraj2729
@dheeraj2729 2 года назад
Recursion with Linked List combined please....
@Phantom_Blox
@Phantom_Blox Год назад
thanks for teaching me how to rob a neighborhood efficiently
@intriqet8776
@intriqet8776 Год назад
I’m so confused. The maps generated in the problems all seem to have unique rules that arent clear to me. Feels like I missed a reading assignment maybe or lecture. The longest subsequence problem was troubling for me. ace. abcde. The matrix and comparisons sounded so natural but seemed convoluted to me. Why is this more efficient than sequence analyzer? Like the subsequence ace is visible in abcde without needing a map. (Granted I don’t know if that means there is a solution that can be computed more easily) These are great I just feel like an idiot cause I feel like I’m doing physics but didn’t learn the kinematic equations or something similar.
@AnkitKumar-jm3cz
@AnkitKumar-jm3cz 2 года назад
Really Awesome work . Thank you so much Bro
@yaswanthkosuru
@yaswanthkosuru 2 года назад
really learning dp from a google employer is a god grace
@ionguzun3952
@ionguzun3952 2 года назад
Nice video...can u please do a video about sliding window technique
@abhaytiwari5991
@abhaytiwari5991 2 года назад
Well done bro👏👏👏👏👏👏
@sebastianestrada1311
@sebastianestrada1311 Год назад
You sound like the frontend expert teacher in algo expert
@MukulDuttshades
@MukulDuttshades 2 года назад
Thank you🫂
@beyond-convention
@beyond-convention Год назад
Hi Your whiteboard is amazing. Which tool do you use for whiteboarding
@rohanaurangabadkar951
@rohanaurangabadkar951 6 месяцев назад
I am a sought of person who doesn't have any idea regarding dp, so can i watch it or not.
@ScaryYokai
@ScaryYokai 2 года назад
Thanks !!!
@s8x.
@s8x. Год назад
What’s the difference between this and recursion
@honas908
@honas908 Год назад
how is the palindrome question related to dynamic programming? (Great vids, btw!)
@Felix-lw7wo
@Felix-lw7wo Год назад
In DP for the 5th a stair, why is the value 5 and not 0?
@ИринаГусев-р9ю
@ИринаГусев-р9ю 2 года назад
When I see your video I realize the next 3 hours are gonna be coool
@Aryan-wl7mc
@Aryan-wl7mc 2 года назад
Legend is back 🔥🔥🔥
@parkourbee2
@parkourbee2 2 года назад
Why is Longest Palindromic Substring considered DP??
Далее
Dynamic Programming 2D - Full Course - Python
3:16:44
Просмотров 108 тыс.
How I would learn Leetcode if I could start over
18:03
Просмотров 540 тыс.
Boxing !! 😂
00:21
Просмотров 3,8 млн
Most Common Concepts for Coding Interviews
6:08
Просмотров 316 тыс.
20 System Design Concepts Explained in 10 Minutes
11:41
Intro to Java Programming - Course for Absolute Beginners
3:48:25
10 Important Python Concepts In 20 Minutes
18:49
Просмотров 130 тыс.